#pragma once
#include <windows.h>

enum AttributeType
{
    ATTRIBUTE_TYPE_STRING,
    ATTRIBUTE_TYPE_INTEGER,
    ATTRIBUTE_TYPE_FLOAT,
    ATTRIBUTE_TYPE_BOOLEAN,
    ATTRIBUTE_TYPE_DATE
};

typedef void (*CreateTagDelegate)(char *name,char *value, AttributeType type,BOOL isDomainValue);
typedef void (*CreateTagWithoutTypeDelegate)(char *name,char *value);

typedef struct {
	CreateTagDelegate createTag; // method to create a new tag
	WCHAR  *libraryPath;         // directory of the library
	WCHAR  *patchPath;           // relative patch of the patch
	WCHAR  *Fullpath;            // full path of the patch
	HANDLE  handle;              // low level stream handle
	void   *stream;              // internal use only
	INT32   CRC32;               // checksum of the patch
	void   *patch;               // internal use only

	// method to create a new tag without provinding any type. 
    // UniversalPatchFinder.ini must contain the definition of it
    // (if not, the method does nothing)
	CreateTagWithoutTypeDelegate createTagWithoutType;
} UPFContext;